#include "aoisegmentation.h"
#include "cv/grabcut.h"
#include <QProgressDialog>
#include <QtConcurrent>

AoiSegmentation::AoiSegmentation(DataState *state):state(state)
{

}

void AoiSegmentation::runSegmenation()
{
    // Create a progress dialog.
    QProgressDialog *dialog = new QProgressDialog(QString("Segment tracking"), "Abort",0,0);
    dialog->setWindowModality(Qt::WindowModal);

    // Create a QFutureWatcher and connect signals and slots.
    QFutureWatcher<void> futureWatcher;
    QObject::connect(&futureWatcher, SIGNAL(finished()), dialog, SLOT(reset()));
    QObject::connect(dialog, SIGNAL(canceled()), &futureWatcher, SLOT(cancel()));

    //create wrapper

    segmentationWrapper wrap(this);

    // Start the computation.
    futureWatcher.setFuture(QtConcurrent::map(state->vid->frameVector, wrap));

    // Display the dialog and start the event loop.
    dialog->exec();
    futureWatcher.waitForFinished(); //block main application
    delete dialog;

}

void AoiSegmentation::segmentation(int &iteration)
{
    qDebug()<<"thead"<<iteration;
    int index = state->vid->frameVector.indexOf(iteration);
    int start = 0;

    if(index>0)
        start = state->vid->frameVector.at(index-1);

    for (int i = start ; i < iteration; ++i) {
        if(state->getCurrentObject()->keyFrames.at(i)->type==3 || state->getCurrentObject()->keyFrames.at(i)->type==1){
            GrabCut* segment =new GrabCut(state->vid->getFramePath(i),state->getCurrentObject()->keyFrames.at(i)->polygon);
            segment->segmentImage(2,1);
            state->getCurrentObject()->keyFrames.at(i)->setNewPolygon(segment->getObjectBondary());
        }
    }
}
