#include "imageprocess.h"

ImageProcess::ImageProcess(QString framePath):
    image(cv::imread(framePath.toUtf8().constData(), CV_LOAD_IMAGE_COLOR))
{
}

cv::Mat ImageProcess::crop(QPolygonF polyArea)
{
    qreal x1=0,x2=0,y1=0,y2=0;
    getBoundingRect(polyArea,x1,x2,y1,y2);
    cv::Rect roi(round(x1),round(y1),round(x2-x1),round(y2-y1));
    return image(roi);
}

void ImageProcess::getBoundingRect(QPolygonF polyArea,qreal &x1, qreal &x2, qreal &y1, qreal &y2){
    polyArea.boundingRect().getCoords(&x1,&y1,&x2,&y2);
    checkSize(x1,x2,y1,y2);
}

void ImageProcess::checkSize(qreal &x1, qreal &x2, qreal &y1, qreal &y2)
{
    if (x1<0)x1=0;
    else if (x1>image.cols)
        x1=image.cols-1;

    if (x2<0) x2=0;
    else if (x2>image.cols)
        x2=image.cols;

    if (y1<0) y1=0;
    else if (y1>image.rows)
        y1=image.rows-1;

    if (y2<0) y2=0;
    else if (y2>image.rows)
        y2=image.rows;
}
