#ifndef POLYAREAGRAPHICSITEM_H
#define POLYAREAGRAPHICSITEM_H

#include <QObject>
#include <QGraphicsPolygonItem>
#include <QGraphicsScene>
#include <QGraphicsSceneMouseEvent>
#include <QList>

#include "../Models/keyframe.h"
#include "polypointgraphicsitem.h"

class PolyAreaGraphicsItem : public QObject, public QGraphicsPolygonItem
{
    Q_OBJECT
public:
    PolyAreaGraphicsItem(QGraphicsScene* s, KeyFrame* kf);

    KeyFrame * keyframe;

    QPointF move;
    QRectF moveBoundingBox;

    QList<PolyPointGraphicsItem* > polyPoints;

signals:
    void moved(int id);
    void changed(int id);
    void clicked(int id);

public slots:
    void redrawFromPolyPoints();
    void polyPointsChanged();
    void updateStyle();
    void updatePolygon();
    void filterKeyFrameChange(int f);
    void filterStateChange(int f);

    void movePolygon();

protected:
    void mousePressEvent(QGraphicsSceneMouseEvent *event);
    void mouseMoveEvent(QGraphicsSceneMouseEvent *event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *event);
};

#endif // POLYAREAGRAPHICSITEM_H
