#ifndef FRAMESPAN_H
#define FRAMESPAN_H

#include <QObject>
#include <QDataStream>

class TrackedObject;

class FrameSpan : public QObject
{
    Q_OBJECT
public:
    enum Type {
        NotSet,
        Visible,
        Occluded
    };

    enum ChangeFlags {
        TypeChange = 1<<0
    };

    explicit FrameSpan(TrackedObject* obj, Type t, int prev, int next);

    //define << operator
    friend QDataStream& operator<<(QDataStream& out, const FrameSpan &outPut){
        out<<int(outPut.type);
        out<<outPut.prevFrame;
        out<<outPut.nextFrame;
        return out;
    }
    //define >> operator
    friend QDataStream& operator>>(QDataStream& in, FrameSpan &inPut){
        int tmp=0;
        in>>tmp;
        inPut.type=Type(tmp);
        in>>inPut.prevFrame;
        in>>inPut.nextFrame;
        return in;
    }

    TrackedObject* object;
    Type type;

    int prevFrame;
    int nextFrame;

signals:
    void hasChanged(int f);

public slots:

    void setType(Type t);
};

#endif // FRAMESPAN_H
